
/**
 * Primera clase para probar encapsulacion
 *
 * @author G. Cherencio
 * @version 1.0
 */
public class Prueba {
    // instance variables - replace the example below with your own
    private int x;       // tipo de dato primitivo, int
    private String msg;  // referencia a un objeto de tipo String
    private String usoThis; // para ejemplificar el uso de this
    
    // constructores
    public Prueba() {
        this(1);
    }
    public Prueba(int x) {
        this(x,"");
    }
    public Prueba(int x,String msg) {
        this(x,msg,"");
    }
    public Prueba(int x,String msg,String usoThis) {
        setX(x);
        setMsg(msg);
        setUsoThis(usoThis);
    }
    // metodos
    // getters
    public int getX() { 
        return x;
    }
    public String getMsg() {
        return msg;
    }
    
    // setters
    public void setX(int valor) {
        if ( valor >= 1 && valor <= 100 ) x = valor;
        else System.err.println("" + valor + " es incorrecto (1-100)");
        
    }
    public void setMsg(String valor) {
        msg = valor;
    }
    
    // usoThis es el argumento del metodo setUsoThis()
    // this.usoThis es el atributo usoThis
    public void setUsoThis(String usoThis) { 
        this.usoThis = usoThis;  // usoThis es una variable local, mientras que this.usoThis es un atributo de la clase
    }
    
    public Prueba sumar(int numero) {
        setX(getX()+numero);
        return this;
    }
}